<template>
  <div class="app-container">
    <el-row :gutter="20">
      <el-col :span="3" :xs="24" style="margin-top: 30px">
        <!-- <div class="head-container">
          <el-input v-model="dwName" placeholder="请输入部门名称" clearable size="small" prefix-icon="el-icon-search"
            style="margin-bottom: 15px" />
        </div> -->
        <el-collapse v-model="index" accordion>
          <div
            class="info1"
            v-for="(item, index) in deptOptions"
            :key="'info1-' + index"
          >
            <el-collapse-item>
              <template #title>
                <div class="projectItem">
                  <div>
                    <!--面板标题-->
                    <p class="title">{{ item.dwName }}</p>
                  </div>
                </div>
              </template>
              <div
                style="
                  display: flex;
                  flex-direction: column;
                  align-items: center;
                "
              >
                <span
                  class="txt"
                  v-for="(items, index) in item.dwDepts"
                  :key="index"
                  @click="mianban(items.id)"
                  >{{ items.dwDeptName }}</span
                >
              </div>
            </el-collapse-item>
          </div>
        </el-collapse>
        <!-- <div class="head-container">
          <el-tree :data="deptOptions" :props="defaultProps" :expand-on-click-node="false"
            :filter-node-method="filterNode" ref="tree" node-key="id" default-expand-all highlight-current
            @node-click="handleNodeClick" />
        </div> -->
      </el-col>
      <el-col :span="20" :xs="24">
        <el-form
          :model="queryParams"
          ref="queryForm"
          size="small"
          :inline="true"
          label-width="68px"
        >
          <el-form-item label="时间" prop="applicationTime">
            <el-date-picker
              clearable
              v-model="createTimeList"
              @change="dateChangebirthday1"
             :default-time="['00:00:00', '23:00:00']"
              format="yyyy-MM-dd HH:mm:ss"
              value-format="yyyy-MM-dd HH:mm:ss"
              type="daterange"
              range-separator="-"
              start-placeholder="开始日期"
              end-placeholder="结束日期"
              :picker-options="pickerOptions"
            ></el-date-picker>
          </el-form-item>
          <el-form-item>
            <el-button
              type="primary"
              icon="el-icon-search"
              size="mini"
              @click="handleQuery"
              >查询</el-button
            >
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
              >重置</el-button
            >
          </el-form-item>
        </el-form>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" size="mini" @click="dialogVisible = true"
              >生成报告</el-button
            >
          </el-col>
          <el-col :span="1.5">
            <el-button type="primary" size="mini">删除报告</el-button>
          </el-col>
        </el-row>
        <el-table :data="baogaoList" style="width: 100%" border>
          <el-table-column
            prop="bgType"
            label="报告类型"
            width="180"
            :show-overflow-tooltip="true"
            align="center"
          ></el-table-column>
          <el-table-column
            prop="dwName"
            label="单位"
            width="180"
            :show-overflow-tooltip="true"
            align="center"
          ></el-table-column>
          <el-table-column
            prop="batch"
            label="批次"
            :show-overflow-tooltip="true"
            align="center"
          ></el-table-column>
          <el-table-column
            prop="dept"
            label="部门"
            :show-overflow-tooltip="true"
            align="center"
          ></el-table-column>
          <el-table-column
            prop="peopleCount"
            label="总人数"
            :show-overflow-tooltip="true"
            align="center"
          ></el-table-column>
          <el-table-column
            prop="yjCount"
            label="已检"
            :show-overflow-tooltip="true"
            align="center"
          ></el-table-column>
          <el-table-column
            prop="wjCount"
            label="未检"
            :show-overflow-tooltip="true"
            align="center"
          ></el-table-column>
          <el-table-column
            prop="startTime"
            label="开始时间"
            :show-overflow-tooltip="true"
            align="center"
          ></el-table-column>
          <el-table-column
            prop="enfTime"
            label="结束时间"
            :show-overflow-tooltip="true"
            align="center"
          ></el-table-column>
        </el-table>
        <el-dialog
          title="提示"
          :visible.sync="dialogVisible"
          width="30%"
          :before-close="handleClose"
        >
          <el-form
            ref="form"
            :model="form"
            :rules="rules"
            label-width="100px"
            :inline="true"
          >
            <el-form-item label="单位" prop="compId">
              <el-select
                v-model="compId"
                placeholder="请选择单位"
                clearable
                style="width: 200px"
                @change="cmp"
              >
                <el-option
                  v-for="dict in compList"
                  :key="dict.drugManufacturerId"
                  :label="dict.cnName"
                  :value="dict.drugManufacturerId"
                />
              </el-select>
              <!-- <el-input v-model="queryParams.compId" placeholder="请输入单位" clearable @keyup.enter.native="handleQuery" style="width: 170px"/> -->
            </el-form-item>
            <el-form-item label="单位部门" prop="dwDeptId">
              <el-select
                v-model="dwDeptId"
                placeholder="请选择单位部门"
                clearable
                style="width: 200px"
              >
                <el-option
                  v-for="dict in dwList"
                  :key="dict.id"
                  :label="dict.dwDeptName"
                  :value="dict.id"
                />
              </el-select>
              <!-- <el-input v-model="queryParams.dwDeptId" placeholder="请输入单位部门" clearable @keyup.enter.native="handleQuery" style="width: 110px"/> -->
            </el-form-item>
          </el-form>
          <span slot="footer" class="dialog-footer">
            <el-button @click="dialogVisible = false">取 消</el-button>
            <el-button type="primary" @click="baogao">生成分析报告</el-button>
          </span>
        </el-dialog>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import {
  getTeam,
  getTeamTjBaoGaoList,
  getDeptAndDwDeptByComp,
} from "@/api/team/disease";
import { listComp } from "@/api/system/comp";
import { getNewDateList } from "@/api/hosp/order";
import moment from "moment";
export default {
  data() {
    let checkPhoneNum = (rule, value, callback) => {
      console.log(value);
      let patter = new RegExp(/^1\s*[3456789]\s*(\d\s*){9}$/);
      if (value == "" && value == undefined && !value) {
        return callback("");
      } else if (value != undefined && value != "") {
        return callback();
      } else if (!patter.test(value)) {
        return callback("");
      }
    };
    return {
      firmId: "",
      firmDeptId: "",
      compId: "",
      dwDeptId: "",
      compList: [],
      dwList: [],
      baogaoList: [],
      index: 0,
      label: "",
      dwName: "",
      defaultProps: {
        children: "dwDepts",
        label: "dwName",
      },
      // 部门树选项
      deptOptions: undefined,
      // 部门名称
      deptName: undefined,
      tableData1: [],
      form: {},
      dialogVisible: false,
      dialogVisible1: false,
      createTimeList: [],
      queryParams: {
        beginTime: null,
        endTime: null,
        dwDeptId: null,
      },
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      // 表单校验
      rules: {
        compId: [
          {
            required: true,
            validator: checkPhoneNum,
            trigger: "blur",
          },
        ],
        dwDeptId: [
          {
            required: true,
            validator: checkPhoneNum,
            trigger: "blur",
          },
        ],
      },
    };
  },
  created() {
    this.getDeptTree();
    // this.getNowTime();
    this.getcomp();
    this.getdate();
  },
  methods: {
    getdate() {
      getNewDateList().then((res) => {
        this.createTimeList = [
          moment(res.data).format("YYYY-MM-DD 00:00:00"),
          moment(res.data).format("YYYY-MM-DD 23:59:00"),
        ];
      });
    },
    /** 查询体检单位信息维护列表 */
    getcomp() {
      listComp().then((response) => {
        this.compList = response.rows;
      });
    },
    // 根据单位查询部门和单位部门信息
    cmp(val) {
      let compId = val;
      getDeptAndDwDeptByComp(compId).then((res) => {
        this.dwList = res.data;
      });
    },
    // / 处理默认选中当前日期
    getNowTime() {
      var curDate = new Date().getTime();
      var dayNum = 7 * 24 * 3600 * 1000;
      var threeDays = curDate - dayNum;
      var sDay = this.getLocalTime(threeDays);
      var end = this.getLocalTime(curDate);
      this.createTimeList = [sDay, end];
    },
    add0(m) {
      return m < 10 ? "0" + m : m;
    },
    getLocalTime(nS) {
      var time = new Date(nS);
      var y = time.getFullYear();
      var m = time.getMonth() + 1;
      var d = time.getDate();
      return y + "-" + this.add0(m) + "-" + this.add0(d);
    },
    /** 查询部门下拉树结构 */
    getDeptTree() {
      getTeam().then((response) => {
        this.deptOptions = response.data;
      });
    },
    // 节点单击事件
    handleNodeClick(data) {
      this.queryParams.deptId = data.id;
      this.handleQuery();
    },
    mianban(id) {
      this.queryParams.beginTime = this.createTimeList[0];
      this.queryParams.endTime = this.createTimeList[1];
      this.queryParams.dwDeptId = id;
      getTeamTjBaoGaoList(this.queryParams).then((res) => {
        this.baogaoList = res.data;
      });
    },
    handleClose(done) {
      this.dialogVisible = false;
      this.dialogVisible1 = false;
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.page = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
      this.loading = true;
    },
    dateChangebirthday1(val) {
      this.createTimeList = val;
    },
    baogao() {
      console.log(this.firmId);
      console.log(this.firmDeptId);
      this.firmId = this.compId;
      this.firmDeptId = this.dwDeptId;
      if (this.firmId === "" || this.firmDeptId === "") {
        this.$message.warning("请选择单位和单位部门！");
      } else {
        const firmId = this.firmId;
        const firmDeptId = this.firmDeptId;
        const viewNum = "858579252534800384";
        const params = { viewNum, firmId, firmDeptId };
        this.$tab.openPage("团队报告", "/report/groupReport", params);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.txt {
  margin-top: 10px;
}
.txt:hover {
  cursor: pointer;
}
</style>